//+------------------------------------------------------------------+ 
//|                                                         DEMA.mq4 | 
//|                                Double Exponential Moving Average | 
//|                                       Copyright  2006, firedave | 
//|                                        http://www.fx-review.com/ | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2006, firedave" 
#property link      "http://www.fx-review.com/" 

#property indicator_chart_window 
#property indicator_buffers 1 

#property indicator_color1 DodgerBlue
#property indicator_level1 0
#property indicator_width1 2

extern int 
      EMA1period     = 5,
      EMA2period     = 5,
      EMAPrice       = PRICE_CLOSE;
      
double 
      TS[],
      EMA1buffer[];

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
   IndicatorBuffers(3);  

   IndicatorShortName("DEMA ("+EMA1period+","+EMA2period+")"); 
    
   SetIndexBuffer(0,TS);
   SetIndexBuffer(1,EMA1buffer); 
   
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2, DodgerBlue); 
   SetIndexStyle(1, DRAW_NONE);
   
   SetIndexDrawBegin(0,2); 
   SetIndexLabel(0,"DEMA");   
              
   return(0); 
  } 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
   return(0); 
  } 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int   i,
         limit,
         counted_bars=IndicatorCounted(); 
               

//---- check for possible errors
   if(counted_bars<0) return(-1); 

//---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 

   limit=Bars-counted_bars; 

   for (i=limit-1; i>=0; i--) EMA1buffer[i] = iMA(NULL,0,EMA1period,0,MODE_EMA,EMAPrice,i);   

//---- main indicator     
   for (i=limit-1; i>=0; i--) TS[i] = iMAOnArray(EMA1buffer,0,EMA2period,0,MODE_EMA,i);

   return(0); 
  } 
//+------------------------------------------------------------------+ 

